Clazz.declarePackage ("jalview.util");
Clazz.load (["java.util.regex.Pattern"], "jalview.util.StringUtils", ["java.lang.StringBuffer", "java.util.ArrayList"], function () {
c$ = Clazz.declareType (jalview.util, "StringUtils");
c$.insertCharAt = Clazz.defineMethod (c$, "insertCharAt", 
function ($in, position, count, ch) {
var tmp =  Clazz.newCharArray ($in.length + count, '\0');
if (position >= $in.length) {
System.arraycopy ($in, 0, tmp, 0, $in.length);
position = $in.length;
} else {
System.arraycopy ($in, 0, tmp, 0, position);
}var index = position;
while (count > 0) {
tmp[index++] = ch;
count--;
}
if (position < $in.length) {
System.arraycopy ($in, position, tmp, index, $in.length - position);
}return tmp;
}, "~A,~N,~N,~S");
c$.deleteChars = Clazz.defineMethod (c$, "deleteChars", 
function ($in, from, to) {
if (from >= $in.length || from < 0) {
return $in;
}var tmp;
if (to >= $in.length) {
tmp =  Clazz.newCharArray (from, '\0');
System.arraycopy ($in, 0, tmp, 0, from);
to = $in.length;
} else {
tmp =  Clazz.newCharArray ($in.length - to + from, '\0');
System.arraycopy ($in, 0, tmp, 0, from);
System.arraycopy ($in, to, tmp, from, $in.length - to);
}return tmp;
}, "~A,~N,~N");
c$.getLastToken = Clazz.defineMethod (c$, "getLastToken", 
function (input, token) {
if (input == null) {
return null;
}if (token == null) {
return input;
}var st = input.$plit (token);
return st[st.length - 1];
}, "~S,~S");
c$.separatorListToArray = Clazz.defineMethod (c$, "separatorListToArray", 
function (input, delimiter) {
var seplen = delimiter.length;
if (input == null || input.equals ("") || input.equals (delimiter)) {
return null;
}var jv =  new java.util.ArrayList ();
var cp = 0;
var pos;
var escape;
var wasescaped = false;
var wasquoted = false;
var lstitem = null;
while ((pos = input.indexOf (delimiter, cp)) >= cp) {
escape = (pos > 0 && input.charAt (pos - 1) == '\\') ? -1 : 0;
if (wasescaped || wasquoted) {
jv.set (jv.size () - 1, lstitem = lstitem + delimiter + input.substring (cp, pos + escape));
} else {
jv.add (lstitem = input.substring (cp, pos + escape));
}cp = pos + seplen;
wasescaped = escape == -1;
wasquoted = jalview.util.StringUtils.DELIMITERS_PATTERN.matcher (lstitem).matches ();
}
if (cp < input.length) {
var c = input.substring (cp);
if (wasescaped || wasquoted) {
jv.set (jv.size () - 1, lstitem + delimiter + c);
} else {
if (!c.equals (delimiter)) {
jv.add (c);
}}}if (jv.size () > 0) {
var v = jv.toArray ( new Array (jv.size ()));
jv.clear ();
if (false) {
System.err.println ("Array from '" + delimiter + "' separated List:\n" + v.length);
for (var i = 0; i < v.length; i++) {
System.err.println ("item " + i + " '" + v[i] + "'");
}
}return v;
}if (false) {
System.err.println ("Empty Array from '" + delimiter + "' separated List");
}return null;
}, "~S,~S");
c$.arrayToSeparatorList = Clazz.defineMethod (c$, "arrayToSeparatorList", 
function (list, separator) {
var v =  new StringBuffer ();
if (list != null && list.length > 0) {
for (var i = 0, iSize = list.length; i < iSize; i++) {
if (list[i] != null) {
if (v.length () > 0) {
v.append (separator);
}v.append (list[i]);
}}
if (false) {
System.err.println ("Returning '" + separator + "' separated List:\n");
System.err.println (v);
}return v.toString ();
}if (false) {
System.err.println ("Returning empty '" + separator + "' separated List\n");
}return "" + separator;
}, "~A,~S");
c$.DELIMITERS_PATTERN = c$.prototype.DELIMITERS_PATTERN = java.util.regex.Pattern.compile (".*='[^']*(?!')");
Clazz.defineStatics (c$,
"DEBUG", false);
});
